/*******************************************************************************

  Tomasz Sadowski
  ICA v1.1

*******************************************************************************/

#include <cstdlib>
#include <iostream>
#include <math.h>


using namespace std;

class statystyka
{
  public:
    double* liczby;
    
    int ilosc_liczb;
    
    double srednia();
    
    double srednia(int*);
    
    double wariancja();
    
    double wspolczynnik_asymetrii();
    
    double odchyelenie();
    
    statystyka();
  
};
statystyka::statystyka()
{
  this->liczby = new double[15];
  this->ilosc_liczb = 15;
  for(int i=1;i<=ilosc_liczb;i++)this->liczby[i-1]=i;
}
double statystyka::srednia()
{
  double suma =0.0;
  int i;
  for(i=0;i<ilosc_liczb;i++)
  {
    suma = suma + this->liczby[i];
  }
  return suma/i;
}
double statystyka::srednia(int* tab_liczb)
{
  double suma =0.0;
  int i;
  for(i=0;i<ilosc_liczb;i++)
  {
    suma = suma + this->liczby[i];
  }
  return suma/i;
}
double statystyka::wariancja()
{
  double suma = 0.0;
  for(int i=0;i<ilosc_liczb;i++)
  {
    suma = suma+liczby[i]*liczby[i];
  }
  double srdeni_kwadrat =  suma/ilosc_liczb;
  return (srdeni_kwadrat - srednia()*srednia());
}
double statystyka::wspolczynnik_asymetrii()
{
  double suma =0;
  for(int i=0;i<ilosc_liczb;i++)
  {
    suma = 
suma+(liczby[i]-srednia())*(liczby[i]-srednia())*(liczby[i]-srednia());
  }
  return suma/wariancja()*wariancja()*wariancja();
}
double tgh(double x)
{
  
  return (exp(x)-exp(-x))/(exp(x)+exp(-x));
}
double kurtoza(double* y,int ilosc_y)
{
  statystyka test;
  test.liczby = y;
  test.ilosc_liczb = ilosc_y;
  double* temp = new double [ilosc_y];
  for(int i=0;i<ilosc_y;i++)temp[i]=pow(y[i]-test.srednia(),4);
  test.liczby =temp;
  double srednia_4 = test.srednia();
  for(int i=0;i<ilosc_y;i++)temp[i]=pow(y[i]-test.srednia(),2);
  double srednia_2 = test.srednia()*test.srednia();
  return (srednia_4/srednia_2) - 3;
}
double det(double** w)
{
  return w[0][0]*w[1][1]-w[0][1]*w[1][0];
}
double myabs(double a)
{
  if(a>=0)return a;
  return -1.0*a;
}
int main(int argc, char *argv[])
{
    srand(time(0)%100);
    double** x = new double* [2];// ilosc wierszy
    for(int i=0;i<2;i++)
    {
      x[i] = new double [200];//ilosc kolumn
    } 

    for(int j=0;j<200;j++)
    {
      x[0][j]=2*cos(0.3*j)+pow(-1,rand()%2)*0.2;
      
      x[1][j]= cos(0.3*j)+pow(-1,rand()%2)*0.9;
    }
    double** w = new double* [2];// ilosc wierszy
    for(int i=0;i<2;i++)
    {
      w[i] = new double [2];//ilosc kolumn
    } 
    for(int i=0;i<2;i++)
    {
      for(int j=0;j<2;j++)
      {
        w[i][j]=-1.0;
      }
    }
    //double suma = 0.0;
    
    double* W = new double [2];
    double wartosc_najwieksza = -10000.0;
    double** S = new double*[2];
    for(int i=0;i<2;i++)
    {
      S[i]= new double[200];
    }
    
    for(w[0][0]=-1;w[0][0]<1;w[0][0]+=0.1)
    {
      //cout << w[0][0]<<" ";
      
       for(w[0][1]=-1;w[0][1]<1;w[0][1]+=0.1)
       {
          for(w[1][0]=-1;w[1][0]<1;w[1][0]+=0.1)
          {
             for(w[1][1]=-1;w[1][1]<1;w[1][1]+=0.1)
             {
               
               double suma = 0.0;
               if(det(w)<0)
               {
                 //cout<<"p";
               continue;}
               for(int zzz = 0;zzz<200;zzz++)
               {
                 S[0][zzz] = w[0][0]*x[0][zzz]+w[0][1]*x[1][zzz];
                 S[1][zzz] = w[1][0]*x[0][zzz]+w[1][1]*x[1][zzz];
               //  suma = suma + log(1-pow(tanh(S[0][zzz]),2))+log(pow(1-tanh(S[1][zzz]),2));
                 suma=suma+log(1-tanh(pow(w[0][0]*x[0][zzz]+w[0][1]*x[1][zzz],2)))+log(1-tanh(pow(w[1][0]*x[0][zzz]+w[1][1]*x[1][zzz],2)));
               }
            //   cout << "suma="<< suma<<"\n";
               suma = suma+200*log(det(w));
               if(suma>wartosc_najwieksza)
               {
                 wartosc_najwieksza = suma;
                 cout << "zmieniono najwieksza wartosc L ="<<wartosc_najwieksza<<"\n";
                 cout << "parametry w[0][0]="<< w[0][0]<<" w[0][1]="<< w[0][1]<<" w[1][0]="<< w[1][0]<<" w[1][1]="<< w[1][1]<<"\n";
               }
             }
          }
       }
    }
    cout << "\n-----------------------\nNajwieksza wartosci wynosi "<<wartosc_najwieksza<<"\n";
    
    
    
    
    system("PAUSE");
    return EXIT_SUCCESS;
}
